#ifndef WOBULATION_H
#define WOBULATION_H

#include <QtWidgets/QDialog>
#include "ui_wobulation.h"
#include "dmd.h"
#include "tango.h"
#include "lc8.h"
#include "itemdlg.h"
#include <QCheckBox>

#define USE_DELAYED_SHIFT

class Wobulation : public QDialog
{
	Q_OBJECT

public:
	Wobulation(QWidget *parent = 0, Qt::WindowFlags flags = 0);
	~Wobulation();

private slots:
	void slotUVConncected();
	void slotUVIntensity(int percent);

	void slotUVPortSetBtnClicked();
	void slotStagePortSetBtnClicked();

	void slotStageUpBtnPressed();
	void slotStageDownBtnPressed();
	void slotStageLeftBtnPressed();
	void slotStageRightBtnPressed();

	void slotListAddBtnClicked();
	void slotListDelBtnClicked();
	void slotListClearBtnClicked();
	//void slotListLoadBtnClicked();
	//void slotListSaveBtnClicked();

	void slotTableDoubleClicked(int row, int column);

	void slotMaskBtn1Clicked();
	void slotMaskBtn2Clicked();

	void slotTotalTimeEdited(const QString &text);
	void slotCycleEdited(const QString &text);
	void slotCycleTimeChanged(const QString &text);

	void slotDurationMask1Edited(const QString &text);
	void slotDurationMask2Edited(const QString &text);

	void slotDurationSequenceMask1Edited(const QString &text);
	void slotDurationSequenceMask2Edited(const QString &text);
	void slotUpdateDurationSequenceNumber();

	void slotRunBtnClicked();
	void slotUVShutterOpened();
	void slotDMDCleared();

#ifdef USE_DELAYED_SHIFT
	void slotDelayedShiftTimeExpired();
#endif

private:
	Ui::WobulationClass ui;

#ifdef USE_WLP_DMD
	QString m_strFileNameMask1, m_strFileNameMask2;
#endif

	DMD *m_pDDC1100;
	CTango *m_pTango;
	LC8Control *m_pLC8Ctrl;

	QString curDir;

	int m_nCurListIndex, m_nCurListRepeatNum, m_nListRepeatNum;

	int m_nBufNumMask1, m_nBufNumMask2, m_nBufNumIndex;
	int m_nCurCycle, m_nCurDurationSequence, m_nCycle, m_nCycleTime, m_nDurationMask1, m_nDurationMask2, m_nDurationSequenceMask1, m_nDurationSequenceMask2, m_nDurationSequenceStep, m_nDurationSequence;
	int m_nShiftX, m_nShiftY, m_nInterSequenceShiftX, m_nInterSequenceShiftY;
	bool m_bDurationSequenceChecked;
	
#ifdef USE_DELAYED_SHIFT
	int m_nShiftDelay;
#endif

	int m_nRunMode;

	bool checkMode1Settings(void);
	bool checkMode2Settings(void);

	QCheckBox *m_pNSFlip, *m_pWEFlip;
};

#endif // WOBULATION_H
